// Venn.h
// Copyright (c) 1992 by Paul Burchard.
// May be used in any form with appropriate acknowledgement.

#import <appkit/Control.h>
#import "VennCell.h"

@interface Venn : Control

- initFrame:(const NXRect *)frameRect;

// Setting the state.
- setStateReplace:sender;
- setStateRefine:sender;
- setStateAdd:sender;
- setStateRemove:sender;
- setStateReverse:sender;
- takeStateFrom:sender;
- takeStateFromIntValue:sender;
- setState:(int)value;
- setStateFromOp:(BOOLOP)anOp;

// Testing the state.
- (int)state;
- (BOOL)evalOp:(BOOL)arg1 :(BOOL)arg2;

// Setting and testing appearance parameters.
- setFont:fontObj;
- setBorderWidth:(float)width;
- (float)borderWidth;
- takeFirstTitleFrom:sender;
- takeSecondTitleFrom:sender;
- setFirstTitle:(const char *)aString;
- setSecondTitle:(const char *)aString;
- (const char *)firstTitle;
- (const char *)secondTitle;

// IB handshaking.
- (const char*)inspectorName;
- read:(NXTypedStream *)stream;
- write:(NXTypedStream *)stream;
- awake;

@end

