// Venn.m
// Copyright (c) 1992 by Paul Burchard.
// May be used in any form with appropriate acknowledgement.
//
// Nothing interesting in here...see VennCell.m instead.

#import "Venn.h"
#import <appkit/appkit.h>

@implementation Venn

- initFrame:(const NXRect *)frameRect
{
    [super initFrame:frameRect];
    cell = [[VennCell alloc] init];
    return self;
}

- awake
{
    [super awake];
    [cell awake];
    return self;
}

- (const char*)inspectorName
{
    return "VennInspector";
}

- read:(NXTypedStream *)stream
{
    [super read:stream];
    // Nothing yet.
    return self;
}

- write:(NXTypedStream *)stream
{
    [super write:stream];
    // Nothing yet.
    return self;
}

- setFont:fontObj
{
    [super setFont:fontObj];
    [cell setFont:fontObj];
    return [self update];
}

- setBorderWidth:(float)width
{
    [cell setBorderWidth:width];
    return [self update];
}

- setStateReplace:sender
{
    [cell setStateReplace:sender];
    return [self update];
}

- setStateRefine:sender
{
    [cell setStateRefine:sender];
    return [self update];
}

- setStateAdd:sender
{
    [cell setStateAdd:sender];
    return [self update];
}

- setStateRemove:sender
{
    [cell setStateRemove:sender];
    return [self update];
}

- setStateReverse:sender
{
    [cell setStateReverse:sender];
    return [self update];
}

- takeStateFrom:sender
{
    [cell takeStateFrom:sender];
    return [self update];
}

- takeStateFromIntValue:sender
{
    [cell takeStateFromIntValue:sender];
    return [self update];
}

- setState:(int)value
{
    [cell setState:value];
    return [self update];
}

- setStateFromOp:(BOOLOP)anOp
{
    [cell setStateFromOp:anOp];
    return [self update];
}

- (int)state
{
    return [cell state];
}

- setFirstTitle:(const char *)aString
{
    [cell setFirstTitle:aString];
    return [self update];
}

- setSecondTitle:(const char *)aString
{
    [cell setSecondTitle:aString];
    return [self update];
}

- takeFirstTitleFrom:sender
{
    [cell takeFirstTitleFrom:sender];
    return [self update];
}

- takeSecondTitleFrom:sender
{
    [cell takeSecondTitleFrom:sender];
    return [self update];
}

- (const char *)firstTitle
{
    return [cell firstTitle];
}

- (const char *)secondTitle
{
    return [cell secondTitle];
}

- (float)borderWidth
{
    return [cell borderWidth];
}

- (BOOL)evalOp:(BOOL)arg1 :(BOOL)arg2
{
    return [cell evalOp:arg1 :arg2];
}

@end




