
/* Generated by Interface Builder */

#import <appkit/View.h>
#import <appkit/Application.h>
#import <appkit/PrintInfo.h>
#import <dpsclient/wraps.h>
#import <appkit/Font.h>

#define LINEAR 0
#define LOG 1

@interface NXYView:View
{
    id	  plotParam;
    id plotInspectorPanel;		//Outlet to bring up Inspector panel with right mouse click in view
    id inspector; 
    id delegate;   
    
    float ppxunit, ppyunit;	/* pixels per xunit, pixels per y unit */

//    float xlegend[2], **ylegend;/* for legend drawing (fixed dimension here) */
//    BOOL  drawingLegendLines;
//    NXRect legendbox;

// Instance variables added by Charlie
	char * mainTitle;
	char * xaxisLabel;
	char * yaxisLabel;	
	float xInc;
	float xMin;
	float xMax;
	float yInc;
	float yMin;
	float yMax;
	int gridState;
	int borderState;
	int autoMaxMinState;
	int autoPaperState;
	int xLinLogState;
	int yLinLogState;
	int paperSwitchRow;
	int logoFlag;
}   
 // methods for obtaining values from the Inspector
 -setGrid:(int)grid_state;
- setBorder:(int)border_state;
-(int)gridState;
-(int)borderState;
-setAutoMaxMinState:(int)state;
-(int)autoMaxMinState;
-setAutoPaperState:(int)state;
-(int)autoPaperState;
-setXLinLogState:(int)state;
-(int)xLinLogState;
-setYLinLogState:(int)state;
-(int)yLinLogState;
-setPaperSwitchRow:(int)state;
-(int)paperSwitchRow;
-setLogoFlag:(int)state;
-(int)logoFlag;
-setMainTitle:(char *)mainTITLE;
-setXaxisLabel:(char *)xAxisLabel;
-setYaxisLabel:(char *)yAxisLabel;
-(char *)mainTitle;
-(char *)xaxisLabel;
-(char *)yaxisLabel;
-setXincValue:(float)passedValue;
-setXminValue:(float)passedValue;
-setXmaxValue:(float)passedValue;
-setYincValue:(float)passedValue;
-setYminValue:(float)passedValue;
-setYmaxValue:(float)passedValue;
-(float)xIncValue;
-(float)xMinValue;
-(float)xMaxValue;
-(float)yIncValue;
-(float)yMinValue;
-(float)yMaxValue;
- rightMouseDown:(NXEvent *)theEvent;


- clear:sender;
- clearNXYView:sender;  // Added to clear the view from an external action
- initPlot:sender;
- setDrawColor:(float) color;
- drawLines:sender :(BOOL)xaxislog :(BOOL)yaxislog;
- drawTicMarks:(float)xmin :(float)xmax :(float)ymin :(float)ymax;
- doPrinting:sender;
- copyToPasteboard:sender;     // Copy EPS to pasteboard
//- (NXCoord *)xdata;		/* provide data for drawing the curves */
//- (NXCoord **)ydata;		/* and symbols in the legend box       */
- (int)nPoints;			/* provide no. of points to use in legend drawing */

// Any subclass of View needs to implement its own drawSelf method
- drawSelf: (const NXRect *)rects :(int)rectCount;
- initFrame:(NXRect *)frameRect;

/*
 * We implement the mouseDown method to allow zooming and also to allow
 * moving the legend box.  We lean heavily on the code in the
 * /NextDeveloper/Examples/Mandelbrot directory.
 */
//Added to plot from a stream sent by a Controller for the view
- plotDataFromStream:sender;
- (const char *)inspectorName;	// For palette inspector
- setInspector:anObject;
- setDelegate:anObject;

// Added from version 1.7 of nxyplot:
- saveEPS:sender;
- savePSCode:(char *)aFile;

// For archiving instance variables
- read:(NXTypedStream *)stream;
- write:(NXTypedStream *)stream;

@end


@interface  Object(NXYViewDelegate)

- nxyView:sender provideDataStream:(NXStream **)dataStream;

@end