//
//"Copyright (C) BenaTong 1991,1992  All rights reserved"
//2.00 version 7/27/92
//


#import <objc/Object.h>
#import "Serial.h"

#define 	OK					0
#define	ONHOOK			1
#define	OFFHOOK			2
#define	CONNECTED			3
#define	BUSY				4
#define	DIALING				5
#define	REDIALING			6
#define	IDLE				7
#define	REMOTERING		8
#define	NOCARRIER			9
#define  MODEMRESPONSEERROR 10

//some common register numbers
#define	AUTOANSRING		0
#define	RING_CNT			1
#define	ESC_CHAR			2
#define	RETURN_CHAR		3
#define	LINEFEED_CHAR		4
#define	BS_CHAR			5
#define	WAIT_DIALTONE		6
#define	WAIT_CARRIER		7
#define	LEN_PAUSE			8
#define	CD_GUARD			9
#define	LOST_CDTIME		10
#define	TONE_RATE			11
#define	ESC_GUARD			12
#define  DELAY_DTR			25
#define  RTS_CTS_DELAY		26

struct modemStruct {
	char		type[40];		//name of modem
	char		lastNum[40];	//Last Number dialed
	char		term[3];		//Normal command terminator IE. "\r"
	char		tone[20];		//tone dial prefix
	char		pulse[20];	//pulse dial prefix
	BOOL	toneDial; 		//YES = TONE 	NO=PULSE
	char		hangup[20];	//code to cause a hangUp
	char		reset[20];		//code to reset modem
	char  	answer[20];	//code to cause answer
	};

@interface Modem:Serial
{
	struct modemStruct localModem;
	int		modemStatus;
	int		numRings;
	char		lastResponse[100];
	BOOL	autoAnswerOn;
}



- init;
- (int) getModemStatus;

- defineModem: (struct modemStruct) aModem;
- getModemDef: (struct modemStruct*) aModem;

- (char*) getLastResponse;
- (int) modemReset;
-         modemToneDial:(BOOL)flag;
- (int) modemDial: (char*) number AutoBaud:(BOOL) autoBaud;
- (int) modemRedial:(BOOL) autoBaud;
- (int) modemHangup;
- (int) modemAnswer;
- (int) modemAutoAnswer: (int) numberOfRings;
- (int) modemAutoAnswer;
- (int) modemReadRegister:(int) reg;
- (int) modemWriteRegister:(int) reg  withValue:(int)value;

@end
