#
# NOTE: Do NOT change this file -- InterfaceBuilder depends on it.
#
# useful macros to put into your Makefile.preamble to override the default
# values in the IB-generated Makefile:
#	MAKEFILEDIR
#	TARFILEDIR
#	SOURCEMODE
#	CFLAGS
#	OBJCFLAGS
#	PSWFLAGS
#	LDFLAGS
#	HELP_FILES
#	DATA_FILES
#	INSTALLFLAGS
#	OTHER_LIBS
#	OTHER_DEBUG_LIBS
#	OTHER_PROF_LIBS
#	OTHER_SOURCEFILES
#	OTHER_OFILES
#	OTHER_PRODUCT_DEPENDS
#	OTHER_INSTALL_DEPENDS
#	OTHER_GARBAGE
#

PRODUCT = $(NAME)
OFILE_DIR = obj
SUPPORTFILES = Makefile Makefile.preamble Makefile.postamble
SRCFILES = $(CLASSES) $(CLASSES:.m=.h) \
	$(MFILES) $(CFILES) $(HFILES) \
	$(OTHERSRCS) $(OTHER_SOURCEFILES)
OFILES = $(SUBPROJECTS:.subproj=.o) \
 	$(CLASSES:.m=.o) \
	$(MFILES:.m=.o) $(CFILES:.c=.o)
EARLY_HEADERS = $(SUBPROJECTS:.subproj=.h)
PRODUCT_DEPENDS =  $(EARLY_HEADERS) $(OFILE_DIR) \
	$(OFILES) $(OTHER_OFILES) \
	$(OTHER_PRODUCT_DEPENDS)
INSTALL_DEPENDS = $(DSTROOT)$(INSTALLDIR) all $(OTHER_INSTALL_DEPENDS)
NIBLIBDIR = /usr/lib/nib
GARBAGE = $(NAME) $(NAME).debug $(NAME).profile \
	  obj debug_obj profile_obj \
	  $(OTHER_GARBAGE) gmon.out

_CFLAGS = $(CFLAGS) 
_LDFLAGS = $(LDFLAGS)


#
# user level targets
#

all::
	@$(MAKE) $(PRODUCT)
	
debug $(PRODUCT).debug::
	@$(MAKE) $(NAME).debug "PRODUCT = $(NAME).debug" \
	    "OFILE_DIR = debug_obj" \
	    "_CFLAGS = $(CFLAGS) -g -DDEBUG -Wall" \
	    "LIBS = $(DEBUG_LIBS)" \
	    "OTHER_LIBS = $(OTHER_DEBUG_LIBS)"

profile $(PRODUCT).profile::
	@$(MAKE) $(NAME).profile "PRODUCT = $(NAME).profile" \
	    "OFILE_DIR = profile_obj" \
	    "_CFLAGS = $(CFLAGS) -O -pg -Wall" \
	    "LIBS = $(PROF_LIBS)" \
	    "OTHER_LIBS = $(OTHER_PROF_LIBS)"

clean:: $(NAME).clean $(SUBPROJECTS:.subproj=.clean)

installsrc:: $(NAME).installsrc $(SUBPROJECTS:.subproj=.installsrc)

list:: $(NAME).list

tar:: $(NAME).tar

tarlist:: $(NAME).tarlist

untar:: $(NAME).untar

xtract:: $(NAME).xtract

tardir:: $(NAME).tardir

tardiff:: $(NAME).tardiff

test:: all $(NAME).test

install:: $(INSTALL_DEPENDS) $(NAME).install

lib:: $(NAME).lib

depend:: Makefile.dependencies $(SUBPROJECTS:.subproj=.depend)

help::
	@echo '  all (the default)'
	@echo '  debug'
	@echo '  profile'
	@echo '  clean'
	@echo '  installsrc [SRCROOT=somepath]'
	@echo '  install [DSTROOT=somepath]'
	@echo '  depend'
	@echo '  list'
	@echo '  tar [DATE=date]'
	@echo '  untar [DATE=date]'
	@echo '  tardir'
	@echo '  tarlist [DATE=date]'
	@echo '  xtract [DATE=date] [LIST=file list]'
	@echo '  tardiff [DATE1=date] [DATE2=date]'
	@echo '  test [TEST_OUT=testfile]'
#
# Common functionality
#

include $(MAKEFILEDIR)/common.make

#
# app-specific functionality
#

$(PRODUCT):: $(PRODUCT_DEPENDS)
	@if [ ${NOMACHO} ] ; then \
	    ldflags="$(_LDFLAGS)"; \
	else \
	    ldflags="$(_LDFLAGS)"; \
	    nibseg=no; tiffseg=no; epsseg=no; sndseg=no; \
	    for i in $(SUBPROJECTS:.subproj=.ldflags) none ; do \
		    if [ $$i = none ] ; then continue; fi; \
		    ldflags="$$ldflags `cat $(OFILE_DIR)/$$i`"; \
	    done; \
	fi ; \
	echo $(CC) $(_CFLAGS) $$ldflags -o $(PRODUCT) $(OFILES) \
			$(OTHER_OFILES) $(OTHER_LIBS) $(LIBS) ; \
	$(CC) $(_CFLAGS) $$ldflags -o $(PRODUCT) $(OFILES) $(OTHER_OFILES) \
					 $(OTHER_LIBS) $(LIBS)


