/***************************************************************************
*                                                                          *
* util.h                                                                   *
* Copyright 1992 by Nik A Gervae                                           *
*                                                                          *
* For use with the three Objective-C classes (SktSocketManager, SktSocket, *
* and SktSocketUser) which implement a convenient interface to Berkeley    *
* stream sockets under NeXTSTEP(r).  See the accompanying class            *
* specifications (files with a .rtf or .spec suffix) for further           *
* information.                                                             *
*                                                                          *
* NeXTSTEP is a registered trademark of NeXT Computer, Inc.                *
*                                                                          *
****************************************************************************
*                                                                          *
* LICENSE                                                                  *
*                                                                          *
* This program is free software; you can redistribute it and/or modify     *
* it under the terms of the GNU General Public License as published by     *
* the Free Software Foundation.                                            *
*                                                                          *
* The program and this makefile are distributed in the hope that it will   *
* be useful, but are provided "AS IS" AND WITHOUT ANY WARRANTY; without    *
* any express or implied warranty of MERCHANTABILITY or FITNESS FOR A      *
* PARTICULAR PURPOSE. See the GNU General Public License for more details. *
* Any use or distribution of the program and documentation must include    *
* appropriate copyrights to acknowledge Nik A. Gervae and the Free         *
* Software Foundation, Inc.                                                *
* The program and this makefile are distributed in the hope that it will   *
* be useful, but are provided "AS IS" AND WITHOUT ANY WARRANTY; without    *
* any express or implied warranty of MERCHANTABILITY or FITNESS FOR A      *
* PARTICULAR PURPOSE. See the GNU General Public License for more details. *
* Any use or distribution of the program and documentation must include    *
* appropriate copyrights to acknowledge Nik A. Gervae and the Free         *
* Software Foundation, Inc.                                                *
*                                                                          *
* You should have received a copy of the GNU General Public License        *
* along with this program; if not, write to the Free Software              *
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.                *
*                                                                          *
****************************************************************************
*                                                                          *
* VERSION HISTORY                                                          *
*                                                                          *
* Version numbers are simply dates in the form YYYYMMDD.  These represent  *
* the date that version was finished.  Only significantly changed versions *
* are reported here, or those versions requiring explanation of changes.   *
* There may be many interim stages between dated versions.                 *
*                                                                          *
* DateVersion Primary Author  Notes                                        *
* ----------- --------------- -------------------------------------------- *
* 19920327    Nik A Gervae    First released version                       *
*                                                                          *
***************************************************************************/

#import <stdio.h>
#ifdef NS3
#import <objc/zone.h>
#else
#import <zone.h>
#endif


// Macros

#ifndef	MIN
#define	MIN(a,b) (((a) < (b)) ? (a) : (b))
#endif	MIN
#ifndef	MAX
#define	MAX(a,b) (((a) > (b)) ? (a) : (b))
#endif	MAX

#define ISENDLINE(c)  ((c) == '\n' || (c) == '\r')
#define ISWHITE(c)    ((c) == ' ' || (c) == '\t')
#define CRLF          "\r\n"
#define ISCRLF(s)     ((*(s)) == '\r' && (*((s)+1)) == '\n')
#define ISOPENENT(s)  ((*(s)) == '@'  && (*((s)+1)) == '+')
#define ISCLOSEENT(s) ((*(s)) == '@'  && (*((s)+1)) == '-')

// Functions

int   rstrncmp(const char *str1, const char *str2, int len);
char *strdup(const char *string);
char *strrecat(const char *string1,const char *string2);

char *zoneStrdup(NXZone *zonep, const char *string);
char *zoneStrrecat(NXZone *zonep, const char *string1,const char *string2);
